<header class="offers_table_header">
  <h2>Created Offers</h2>
  @if (newOfferLoading) {
  <button
    class="major-action-button"
    routerLink="../stepper"
    mat-raised-button
    color="primary"
    disabled
    (click)="handleNewOffer()"
  >
    <mat-spinner diameter="24"></mat-spinner>
  </button>
  } @else {
  <button
    class="major-action-button"
    routerLink="../stepper"
    mat-raised-button
    color="primary"
    (click)="handleNewOffer()"
  >
    <mat-icon iconPositionEnd>add</mat-icon> New Offer</button
  >}
</header>
<div class="mat-elevation-z8">
  <table mat-table class="full-width-table" matSort aria-label="Elements">
    <ng-container matColumnDef="id">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>Offer ID</th>
      <td mat-cell *matCellDef="let row">{{ row.id }}</td>
    </ng-container>

    <ng-container matColumnDef="modifiedDtm">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>Last Modified</th>
      <td mat-cell *matCellDef="let row">
        {{ row.modifiedDtm | date : "medium" }}
      </td>
    </ng-container>

    <ng-container matColumnDef="name">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>Name</th>
      <td mat-cell *matCellDef="let row">
        {{
          row.details?.firstName
            ? row.details.firstName + " " + row.details.lastName
            : ""
        }}
      </td>
    </ng-container>

    <ng-container matColumnDef="status">
      <th mat-header-cell *matHeaderCellDef mat-sort-header>Status</th>
      <td mat-cell *matCellDef="let row">
        <mat-chip
          class="offer_status_chip"
          [class]="
            'status-' + (row.status === 'IN_REVIEW' ? 'REVIEWED' : row.status)
          "
          >{{ row.status === "IN_REVIEW" ? "IN REVIEW" : row.status }}</mat-chip
        >
      </td>
    </ng-container>

    <ng-container matColumnDef="actions">
      <th mat-header-cell *matHeaderCellDef>Actions</th>
      <td mat-cell *matCellDef="let row">
        <button
          class="preview-button"
          mat-icon-button
          matTooltip="Preview Offer"
          [disabled]="isDeleteLoading(row.id)"
          (click)="handlePreviewOffer(row.id)"
        >
          <mat-icon>visibility</mat-icon>
        </button>
        <button
          class="edit-button"
          mat-icon-button
          matTooltip="Edit Offer"
          [disabled]="isDeleteLoading(row.id)"
          (click)="handleEditOffer(row.id)"
        >
          <mat-icon>edit</mat-icon>
        </button>
        <button
          class="delete-button"
          mat-icon-button
          matTooltip="Delete Offer"
          [disabled]="isDeleteLoading(row.id)"
          (click)="handleDeleteOffer(row.id)"
        >
          <mat-icon>delete</mat-icon>
        </button>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
  </table>
  @if (tableLoading) {
  <app-spinner></app-spinner>
  }
  <mat-paginator
    #paginator
    [length]="dataSource.data$.value.length"
    [pageIndex]="0"
    [pageSize]="10"
    [pageSizeOptions]="[5, 10, 20]"
    aria-label="Select page"
  >
  </mat-paginator>
</div>
